#!/usr/local/bin/ruby

require 'rbbr_qt'
require 'qt'
include Qt


class RClassMain < QWidget
def initialize
   @toplayout = QVBoxLayout.new(self)
   @menubar = QMenuBar.new(self)
   @popup = QPopupMenu.new
   @popup.insertItemQObj( "&Quit", QApplication::qApp, QSLOT("quit()"), CTRL+Key_Q )
   @menubar.insertItem("&File",@popup)
   @toplayout.setMenuBar(@menubar)
   @classWindow = RClassView.new(self)
   @toplayout.addWidget(@classWindow)
end
end

class RClassView < QWidget
def initialize w
   @split = QSplitter.new(QSplitter::Horizontal,self)
   @classview = QListView.new(@split)
   @classview.addColumn("Ruby Class")
   @classview.setColumnWidthMode(1,QListView::Maximum)
   @classview.setRootIsDecorated( true )

   @w1 = QWidget.new(@split)
   @hblayout = QHBoxLayout.new(@w1)
   @vblayout1 = QVBoxLayout.new(@w1)

   @mlisthead = QLabel.new("Methods",@w1)
   @mlisthead.setFrameStyle(QFrame::Panel | QFrame::Raised)
   @vblayout1.addWidget(@mlisthead)
   @methodlist = QListBox.new(@w1)
   @vblayout1.addWidget(@methodlist)

   @vblayout2 = QVBoxLayout.new(@w1)
   @varlisthead = QLabel.new("Constants",@w1)
   @varlisthead.setFrameStyle(QFrame::Panel | QFrame::Raised)
   @vblayout2.addWidget(@varlisthead)
   @varlist = QListBox.new(@w1)
   @vblayout2.addWidget(@varlist)

   @hblayout.addLayout(@vblayout1)
   @hblayout.addLayout(@vblayout2)

   newheight = @classview.header.height - 10
   @mlisthead.setFixedHeight(newheight)
   @varlisthead.setFixedHeight(newheight)



   @split.resize(width,height)
   @hblayout.activate

   catchEvent

   $walker = ClassTree::new()
   initialize_classview
   Qt::connect(@classview,QSIGNAL("selectionChanged()"),self,"cb_select")


end
def resizeEvent ev
   @split.resize(width,height)
end

def initialize_classview
   roots = initialize_args({"qt" => ["Qt"]})
   STDERR.print roots.inspect+"\n"
   $walker.visit(roots)
   $walker.createDescendantsTree(@classview)
   $walker.createConstantsList(@varlist,nil)
   $walker.createMethodsList(@methodlist, nil)
end

def cb_select
   cname = @classview.currentItem.text(0)
   cls = eval(cname)
   if cls.is_a? Module
   $walker.changeConstants(@varlist,cls)
   $walker.changeMethods(@methodlist,cls)
   end
end
end


a = QApplication.new( [$0] + ARGV)
#Qt::connect( a, QSIGNAL("lastWindowClosed()"), a, QSLOT("quit()") )
w = RClassMain.new
a.setMainWidget(w)

w.show
a.exec

